// Test.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "zlib.h"
#include <cstdio>
#include <cstring>
#include <cstdlib>

// in-memory compression and decompression functions ׽Ʈ

//Compression can be done in a single step if the buffers are large enough (for example if an input file is mmap'ed), 
//or can be done by repeated calls of the compression function. 
//In the latter case, the application must provide more input and/or consume the output (providing more output space) 
//before each call. 

// compressԼ uncompressԼ ׽ƮѴ.
void test_compress()
{
	fprintf(stdout,"< test_compress() >\n\n");
	unsigned char* inbuf;
	unsigned char* outbuf;
	
	unsigned long INBUFSIZE;
	unsigned long OUTBUFSIZE;
	
	
	inbuf=new unsigned char[1000];
	
	strcpy((char*)inbuf,"Is good?");
	INBUFSIZE=strlen((char*)inbuf)+1;

	fprintf(stdout,"׽Ʈ ڿ  .\n");
	fprintf(stdout,"%s\n\n",inbuf);

	//Upon entry, destLen is the total size of the destination buffer, 
	//which must be at least 0.1% larger than sourceLen plus 12 bytes.
	
	//Integer ݿø   1 ߴ. 
	OUTBUFSIZE=(unsigned long)1.001*(INBUFSIZE+12) + 1;
	outbuf=new unsigned char[OUTBUFSIZE];

	//in-memory   Լ compress() compress2() ִ.
	//⼭     ִ compress2()  ڴ.

	//Compression Level   ǵǾ ִ.
	//#define Z_NO_COMPRESSION         0
	//#define Z_BEST_SPEED             1
	//#define Z_BEST_COMPRESSION       9
	//#define Z_DEFAULT_COMPRESSION  (-1)
	int err=compress2(outbuf, &OUTBUFSIZE, inbuf, INBUFSIZE, Z_DEFAULT_COMPRESSION);

	//Compress2Լ    ڵ带 ȯѴ.
	//compress2 returns Z_OK if success, 
	//Z_MEM_ERROR if there was not enough memory, 
	//Z_BUF_ERROR if there was not enough room in the output buffer
	//Z_STREAM_ERROR if the level parameter is invalid
	if( err==Z_OK )
	{
		fprintf(stderr,"compressԼ ߽ϴ.\n\n");
	}
	else
	{
		fprintf(stderr,"࿡ ߽ϴ.\n");
		fprintf(stderr,"Error code = %d\n",err);
		fprintf(stderr,"test_compress \n\n");
		exit(1);
	}

	//uncompress returns Z_OK if success, 
	//Z_MEM_ERROR if there was not enough memory, 
	//Z_BUF_ERROR if there was not enough room in the output buffer, 
	//or Z_DATA_ERROR if the input data was corrupted. 
	err=uncompress(inbuf,&INBUFSIZE,outbuf,OUTBUFSIZE);
	if( err==Z_OK )
	{
		fprintf(stderr,"uncompressԼ     .\n");
		fprintf(stderr,"%s\n\n",inbuf);
	}
	else
	{
		fprintf(stderr,"  ߽ϴ.\n");
		fprintf(stderr,"Error code = %d\n",err);
		fprintf(stderr,"test_compress \n\n");
		exit(1);
	}
	
	delete [] outbuf;
	delete [] inbuf;

}

//reading and writing files in gzip (.gz) format with an interface similar to that of stdio
void test_gzio_write()
{
	fprintf(stderr,"< test_gzio_write() >\n\n");
	
	char* filename;
	filename = new char[100];
	strcpy(filename,"gzip.gz");

	gzFile file;
	int err;
	//켱 gzip  . 
	
	//The mode parameter is as in fopen ("rb" or "wb") 
	//but can also include a compression level ("wb9") or a strategy: 
	//'f' for filtered data as in "wb6f", 'h' for Huffman only compression as in "wb1h". 
	//̳ʸ  б  .
	file = gzopen(filename, "wb");
    
	//gzopen returns NULL 
	//if the file could not be opened or if there was insufficient memory to allocate the (de)compression state ; 
	//errno can be checked to distinguish the two cases 
	//(if errno is zero, the zlib error is Z_MEM_ERROR). 

	//errono can by checked by using "const char * gzerror (gzFile file, int *errnum)" 
	//Returns the error message for the last error which occurred on the given compressed file. 
	//errnum is set to zlib error number. 
	//If an error occurred in the file system and not in the compression library, 
	//errnum is set to Z_ERRNO and the application may consult errno to get the exact error code. 
	if (file == NULL)
	{
        fprintf(stderr, "gzopen(%s,\"wb\") error: %s\n",filename,gzerror(file,&err));
        exit(1);
    }
	else
	{
		fprintf(stderr,"gzopen(%s,\"wb\") succeeded!\n",filename);
	}
	
	// gzip.gz Ͽ "Alicia Keys" Է ڴ.

	//Writes c, converted to an unsigned char, into the compressed file. 
	//gzputc returns the value that was written, or -1 in case of error
    err=gzputc(file, 'A');
	if( err==-1 )
	{
		fprintf(stderr,"gzputc(file,'A') error!\n\n");
		exit(1);
	}
	else
	{
		fprintf(stderr,"gzputc(file,\'%c\') succeeded!\n",err);
	}

	//Writes the given null-terminated string to the compressed file, excluding the terminating null character. 
	//gzputs returns the number of characters written, or -1 in case of error. 
    if (gzputs(file, "licia") == -1 ) 
	{
        fprintf(stderr, "gzputs(file,\"licia\") err: %s\n\n", gzerror(file, &err));
		exit(1);
    }
	else
	{
		fprintf(stderr, "gzputs(file,\"licia\") succeeded!\n");
	}

	//Converts, formats, and writes the args to the compressed file under control of the format string, as in fprintf. 
	//gzprintf returns the number of uncompressed bytes actually written (0 in case of error). 
    if (gzprintf(file, " %s", "Keys") == 0 ) 
	{
		fprintf(stderr, "gzprintf(file, \" %s\") error: \n\n","Keys",gzerror(file,&err));
		exit(1);
	}
	else
	{
		fprintf(stderr, "gzprintf(file, \" %s\") succeeded!\n","Keys");
	}


	/* int gzputs (gzFile file, const char *s) */
	//Writes the given null-terminated string to the compressed file, 
	//excluding the terminating null character. 
	//gzputs returns the number of characters written, or -1 in case of error. 
	int _size=strlen(" good!")+1;
	char* _str=new char[_size];
	strcpy(_str," good!");
	
	if( gzputs(file,_str)==-1 )
	{
		fprintf(stderr,"gzputs(file,\"%s\") error!\n\n",_str);
		exit(1);
	}
	else
	{
		fprintf(stderr,"gzputs(file,\"%s\") succeeded!\n\n",_str);
	}


    // add one zero byte 
    gzseek(file, 1L, SEEK_CUR);
    //gzclose() Լ 
	//Flushes all pending output if necessary, closes the compressed file and deallocates all the (de)compression state.
	//The return value is the zlib error number (see function gzerror below). 
	gzclose(file);

	delete [] _str;
	delete [] filename;
}



void test_gzio_read()
{
	fprintf(stderr,"< test_gzio_read() >\n\n");
	int OUTBUFSIZE;
	char* outbuf;

	char* filename;
	filename = new char[100];
	strcpy(filename,"gzip.gz");

	gzFile file;
	int err;

	//̳ʸ  б  .
	FILE* fin=fopen(filename,"rb");
	if( fin==NULL )
	{
        fprintf(stderr, "fopen(%s,\"rb\") error! \n\n",filename);
        exit(1);
    }
	else
	{
		fprintf(stderr,"fopen(%s,\"wb\") succeeded!\n",filename);
	}

	//켱    ˾Ƴ.
	//gzseek()Լ SEEK_END  ʱ  ⼭ fopen ߴ.
	//gzip   ˰ ִٸ http://www.ietf.org/rfc/rfc1952.txt ϶.
	fseek(fin,-4,SEEK_END);
	fread(&OUTBUFSIZE,sizeof(int),1,fin);
	fprintf(stdout,"Original file size = %d\n",OUTBUFSIZE);

	outbuf=new char[OUTBUFSIZE];

	/* gzip б  . */
	
	//gzopen returns NULL 
	//if the file could not be opened or if there was insufficient memory to allocate the (de)compression state ; 
	//errno can be checked to distinguish the two cases 
	//(if errno is zero, the zlib error is Z_MEM_ERROR). 
	file = gzopen(filename, "rb");

	//errono can by checked by using "const char * gzerror (gzFile file, int *errnum)" 
	//Returns the error message for the last error which occurred on the given compressed file. 
	//errnum is set to zlib error number. 
	//If an error occurred in the file system and not in the compression library, 
	//errnum is set to Z_ERRNO and the application may consult errno to get the exact error code. 
	if (file == NULL)
	{
        fprintf(stderr, "gzopen(%s,\"wb\") error: \n\n",filename,gzerror(file,&err));
        exit(1);
    }
	else
	{
		fprintf(stderr,"gzopen(%s,\"wb\") succeeded!\n\n",filename);
	}

	/* gzread()Լ - gzip  Ѵ. */	
    int _OUTBUFSIZE = gzread(file, outbuf, (unsigned)OUTBUFSIZE);
    if (OUTBUFSIZE != _OUTBUFSIZE) 
	{
        fprintf(stderr,"gzread(file,outbuf,(unsigned)OUTBUFSIZE) err: %s\n", gzerror(file, &err));
		exit(1);
    }
	else
	{
		fprintf(stderr,"File size information provided by Gzip file is correct!\n");
	}

	fprintf(stdout,"gzread():     ϴ.\n");
	fprintf(stdout,"%s\n\n",outbuf);

	//Rewinds the given file. This function is supported only for reading. 
	//gzrewind(file) is equivalent to (int)gzseek(file, 0L, SEEK_SET) 
	gzrewind(file);

	/* gzgets() Լ */
	//Reads bytes from the compressed file until len-1 characters are read, 
	//or a newline character is read and transferred to buf, 
	//or an end-of-file condition is encountered. 
	//The string is then terminated with a null character. 

	//gzgets returns buf, or Z_NULL in case of error. 
    if( gzgets(file, (char*)outbuf, OUTBUFSIZE/2)==Z_NULL )
	{
		fprintf(stderr,"gzgets(file,(char*)outbuf,OUTBUFSIZE/2) failed!\n\n");
		exit(1);
	}
	else
	{
		fprintf(stderr,"gzgets(file,(char*)outbuf,OUTBUFSIZE/2) suceeded!\n");
	}

	fprintf(stdout,"gzgets():     ϴ.\n");
	fprintf(stdout,"%s\n\n",outbuf);


	char _str[2];
	_str[1]='\0';
	
	/* int gzeof(gzFile file) */
	//Returns 1 when EOF has previously been detected reading the given input stream, 
	//otherwise zero. 
	while( gzeof(file)==0 )
	{
		/* int gzgetc (gzFile file) */ 
		//Reads one byte from the compressed file. 
		//gzgetc returns this byte or -1 in case of end of file or error. 
		_str[0]=gzgetc(file);
		strcat(outbuf,_str);
	}
	
	fprintf(stdout,"gzgetc():     ϴ.\n");
	fprintf(stdout,"%s\n\n",outbuf);

    gzclose(file);
	fclose(fin);
}

int main(int argc, char* argv[])
{
	//compressԼ uncompressԼ ׽ƮѴ. 
	test_compress();
	//gzip ϴ utility functions ׽ƮѴ.
	test_gzio_write();
	//gzip о̴ utility functions ׽ƮѴ.
	test_gzio_read();
	return 0;
}

